########## Spatial maps ##########
#set a path to your working folder, where all the files are stored
setwd("C:/___________________/____________/_________________")
#PACKAGES
{
  library("readxl")
  library("dplyr")
  library("car")
  library("gvlma")
  library("ggplot2")
  library("Cairo")
  library("scales")
  library("stargazer")
  library("sandwich")
  library("psych")
  library("lmtest")
  library("robustbase")
  library("texreg")
  library("mice")
  library("VIM")
  library("Amelia")
  library("missForest")
  library("MASS")
  library("lattice")
  library("rJava")
  library("xlsx")
  library("readr")
  library('sampleSelection')
  library('maptools')
  library('classInt')
  library('mapproj')
}

#turn off 1e+05... format. print only normal numbers
options(scipen = 999)

#downdload the data you gonna use to fill the map
x <- read_excel("data.xlsx", col_names = TRUE)
x <- as.data.frame(x)
#downdload the map
regions <- readShapePoly("gadm36_RUS_1.shp")

#some commands to look inside the uploaded map
#...$Name_1 should present with regions as an output
{
#slotNames(regions)
#regions@data
regions@data$NAME_1

#regions@polygons[[1]]@Polygons[[1]]@coords[,1]
#max(regions@polygons[[1]]@Polygons[[1]]@coords[,1])
}



# fix coordinates
{
sma <- -500
smi <- 0
#find wrong area
for(i in 1:83){
  for(j in 1:length(regions@polygons[[i]]@Polygons)){
   
  maval <-  max(regions@polygons[[i]]@Polygons[[j]]@coords[,1])
  mival <-  min(regions@polygons[[i]]@Polygons[[j]]@coords[,1])
  
  if(maval < 0){
    
    if(mival < smi){
      smi <- mival  
    }
    
    if(maval > sma){
    sma <- maval
    }
    }
  }
}
#fix wrong area and place the map in the center of the graph
for(i in 1:83){
  for(j in 1:length(regions@polygons[[i]]@Polygons)){
    maval <-  max(regions@polygons[[i]]@Polygons[[j]]@coords[,1])
    if(maval < 0){
      
      regions@polygons[[i]]@Polygons[[j]]@coords[,1] <- regions@polygons[[i]]@Polygons[[j]]@coords[,1]+360-(abs(smi)-abs(sma))-100+(abs(smi)-abs(sma))  

    } else{
      regions@polygons[[i]]@Polygons[[j]]@coords[,1] <- regions@polygons[[i]]@Polygons[[j]]@coords[,1]-100
    }
  }
}

#rm(i,j,maval, mival, sma, smi)
#rm(regions)
}

# 1: maptools package
{
spplot(regions, "NAME_1", #  
       scales = list(draw = F), # ,    
       col.regions = rainbow(n = 83)) # ,   


regions@data$yourdata <- rnorm(dim(regions@data)[1], 100, 35)
# mypalette <- colorRampPalette(c("seagreen", "whitesmoke"))

# spplot(regions, "yourdata",
#        col.regions = mypalette(83), #   
#        col = "transparent", #     
#        par.settings = list(axis.line = list(col = NA)))

spplot(regions, "yourdata",
       col.regions = heat.colors(n=4), #   
       col = "transparent", #     
       par.settings = list(axis.line = list(col = NA)))


}

# 2_demo_1: ggplot2
{
Rgns <- ggplot2::fortify(regions, region)

ggplot() + geom_map(data = Rgns, 
                    aes(map_id = id), 
                    map = Rgns, color = "gray70") +
  expand_limits(x = Rgns$long, y = Rgns$lat) +
  coord_map("polyconic")

fake_data <- as.data.frame(regions@data)
fake_data$value <- rnorm(nrow(fake_data))
fake_data$id <- seq(0,82,1)

ggplot() + geom_map(data = fake_data,
                    aes(map_id = id, fill = value), 
                    map = Rgns) + 
  expand_limits(x = Rgns$long, y = Rgns$lat) +
  coord_map("polyconic")

}

#rm(Rgns, fake_data, mypalette)



# 2_demo_2: ggplot2 + example with real data
{
Rgns <- ggplot2::fortify(regions, regions)

#simple pic
ggplot() + geom_map(data = x,
                    aes(map_id = id_seq, fill = values), 
                    map = Rgns) + 
  expand_limits(x = Rgns$long, y = Rgns$lat) +
  coord_map("polyconic")



# customize bins (or = breaks) note that values in bins in th.rub
realvalac.levels <- c(0,   30000,   50000,   80000, 200000)
realvalac.labels <- c('0 - 30',    '30 - 50',   '50 - 80', '>80')

x$values.fc <- factor(cut(x$values, realvalac.levels), labels = realvalac.labels)


ggplot(data = x, aes(map_id = id_seq, fill = values)) + 
         geom_map(aes(fill= x$values.fc), colour=1, map = Rgns) +  
  expand_limits(x = Rgns$long, y = Rgns$lat) +
  #  scale_fill_gradientn(colours = c("#56B1F7", "#132B43"), values = x$values, breaks = c(0, 30000, 50000, 80000))+
  coord_map("polyconic")
}








